package com.jjt.rz.service;

import com.jjt.rz.domain.TwinCalcHourRz;
import javafx.util.Pair;

import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.List;
import java.util.Map;

/**
 * 染整线小时工艺参数Service接口
 *
 * @author wukai
 * @date 2025-06-03
 */
public interface ITwinCalcHourRzService {
    /**
     * 查询染整线小时工艺参数
     *
     * @param id 染整线小时工艺参数主键
     * @return 染整线小时工艺参数
     */
    public TwinCalcHourRz selectTwinCalcHourRzById(Long id);

    /**
     * 查询染整线小时工艺参数列表
     *
     * @param twinCalcHourRz 染整线小时工艺参数
     * @return 染整线小时工艺参数集合
     */
    public List<TwinCalcHourRz> selectTwinCalcHourRzList(TwinCalcHourRz twinCalcHourRz);

    /**
     * 新增染整线小时工艺参数
     *
     * @param twinCalcHourRz 染整线小时工艺参数
     * @return 结果
     */
    public int insertTwinCalcHourRz(TwinCalcHourRz twinCalcHourRz);

    /**
     * 修改染整线小时工艺参数
     *
     * @param twinCalcHourRz 染整线小时工艺参数
     * @return 结果
     */
    public int updateTwinCalcHourRz(TwinCalcHourRz twinCalcHourRz);

    /**
     * 批量删除染整线小时工艺参数
     *
     * @param ids 需要删除的染整线小时工艺参数主键集合
     * @return 结果
     */
    public int deleteTwinCalcHourRzByIds(Long[] ids);

    /**
     * 删除染整线小时工艺参数信息
     *
     * @param id 染整线小时工艺参数主键
     * @return 结果
     */
    public int deleteTwinCalcHourRzById(Long id);

    /**
     * 获取上一时段数据
     */
    void last();

    /**
     * 获取当前状态
     *
     * @return 结果
     */
    Map<Integer, Pair<Integer, Integer>> curr();

    /**
     * 按小时获取数据
     *
     * @param start 开始时间
     * @param end   结束时间
     */
    void hour(LocalDateTime start, LocalDateTime end);

    /**
     * 按日期和时间删除数据
     *
     * @param date 日期
     * @param hour 时间
     */
    void deleteTwinCalcHourRz(LocalDate date, int hour);

    /**
     * 补录数据至当前时间
     */
    void calc2Curr();
}
